#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

int xgamepad()
{
int padxval;
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov ah, 084h;
asm mov dx, word ptr 1;
asm int 15h;
asm mov padxval, ax;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
return(padxval);
}

int ygamepad()
{
int padyval;
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov ah, 084h;
asm mov dx, word ptr 1;
asm int 15h;
asm mov padyval, bx;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
return(padyval);
}

int x2gamepad()
{
int pad2xval;
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov ah, 084h;
asm mov dx, word ptr 1;
asm int 15h;
asm mov pad2xval, cx;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
return(pad2xval);
}

int y2gamepad()
{
int pad2yval;
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov ah, 084h;
asm mov dx, word ptr 1;
asm int 15h;
asm mov pad2yval, dx;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
return(pad2yval);
}

int buttongamepad()
{
int buttonval;
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov ah, 084h;
asm mov dx, word ptr 0;
asm int 15h;
asm mov buttonval, ax;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
return(buttonval);
}

void setpage()
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov al, 013h;
asm mov ah, 0;
asm int 10h;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void retpage()
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov al, 03h;
asm mov ah, 0;
asm int 10h;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void plotxyc(int xint, int yint, int cint)
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov ax, cint;
asm mov ah, 0ch;
asm mov cx, xint;
asm mov dx, yint;
asm int 10h;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void spritedef()
{
asm GunDef DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,014,000,000;
asm DB 000,000,014,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,014,000,000;
asm DB 000,014,000,014,000;
asm DB 000,014,014,014,000;

asm BulDef DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,014,000,000;
asm DB 000,000,014,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;

asm ObjDef DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,015,015,015,000;
asm DB 000,000,000,000,000;
asm DB 000,015,015,015,000;
asm DB 000,000,000,000,000;

asm ExpDef DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,013,013,013,000;
asm DB 000,000,000,000,000;
asm DB 000,014,014,014,000;
asm DB 000,000,000,000,000;

asm LivDef DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,012,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,014,000,000;
asm DB 000,000,014,000,000;
asm DB 000,000,014,000,000;
asm DB 000,000,000,000,000;

asm BlkDef DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;

asm Q01Def DB 000,000,000,000,000;
asm DB 000,014,012,014,000;
asm DB 000,000,000,012,000;
asm DB 000,000,000,014,000;
asm DB 000,000,000,012,000;
asm DB 000,000,000,014,000;
asm DB 000,000,000,012,000;
asm DB 000,000,000,000,000;

asm Q02Def DB 000,000,000,000,000;
asm DB 000,000,000,014,000;
asm DB 000,000,000,012,000;
asm DB 000,000,000,014,000;
asm DB 000,000,000,012,000;
asm DB 000,000,000,014,000;
asm DB 000,012,014,012,000;
asm DB 000,000,000,000,000;

asm Q03Def DB 000,000,000,000,000;
asm DB 000,012,000,000,000;
asm DB 000,014,000,000,000;
asm DB 000,012,000,000,000;
asm DB 000,014,000,000,000;
asm DB 000,012,000,000,000;
asm DB 000,014,012,014,000;
asm DB 000,000,000,000,000;

asm Q04Def DB 000,000,000,000,000;
asm DB 000,012,014,012,000;
asm DB 000,014,000,000,000;
asm DB 000,012,000,000,000;
asm DB 000,014,000,000,000;
asm DB 000,012,000,000,000;
asm DB 000,014,000,000,000;
asm DB 000,000,000,000,000;
}

void plotspriteQ04(int xint, int yint)
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov cx, xint;
asm mov dx, yint;
asm mov ax, SEG Q04Def;
asm mov ds, ax;
asm mov ax, OFFSET Q04Def;
asm mov si, ax;
asm mov bl, byte ptr 0;
asm mov bh, byte ptr 0;
repeatQ04Def:;
asm mov al, byte ptr ds:[si];
asm mov ah, 0ch;
asm int 10h;
asm inc si;
asm inc cx;
asm inc bl;
asm cmp bl, byte ptr 5;
asm jl repeatQ04Def;
asm mov bl, byte ptr 0;
asm inc bh;
asm clc;
asm sbb cx, word ptr 5;
asm inc dx;
asm cmp bh, byte ptr 8;
asm jl repeatQ04Def;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void plotspriteQ03(int xint, int yint)
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov cx, xint;
asm mov dx, yint;
asm mov ax, SEG Q03Def;
asm mov ds, ax;
asm mov ax, OFFSET Q03Def;
asm mov si, ax;
asm mov bl, byte ptr 0;
asm mov bh, byte ptr 0;
repeatQ03Def:;
asm mov al, byte ptr ds:[si];
asm mov ah, 0ch;
asm int 10h;
asm inc si;
asm inc cx;
asm inc bl;
asm cmp bl, byte ptr 5;
asm jl repeatQ03Def;
asm mov bl, byte ptr 0;
asm inc bh;
asm clc;
asm sbb cx, word ptr 5;
asm inc dx;
asm cmp bh, byte ptr 8;
asm jl repeatQ03Def;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void plotspriteQ02(int xint, int yint)
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov cx, xint;
asm mov dx, yint;
asm mov ax, SEG Q02Def;
asm mov ds, ax;
asm mov ax, OFFSET Q02Def;
asm mov si, ax;
asm mov bl, byte ptr 0;
asm mov bh, byte ptr 0;
repeatQ02Def:;
asm mov al, byte ptr ds:[si];
asm mov ah, 0ch;
asm int 10h;
asm inc si;
asm inc cx;
asm inc bl;
asm cmp bl, byte ptr 5;
asm jl repeatQ02Def;
asm mov bl, byte ptr 0;
asm inc bh;
asm clc;
asm sbb cx, word ptr 5;
asm inc dx;
asm cmp bh, byte ptr 8;
asm jl repeatQ02Def;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void plotspriteQ01(int xint, int yint)
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov cx, xint;
asm mov dx, yint;
asm mov ax, SEG Q01Def;
asm mov ds, ax;
asm mov ax, OFFSET Q01Def;
asm mov si, ax;
asm mov bl, byte ptr 0;
asm mov bh, byte ptr 0;
repeatQ01Def:;
asm mov al, byte ptr ds:[si];
asm mov ah, 0ch;
asm int 10h;
asm inc si;
asm inc cx;
asm inc bl;
asm cmp bl, byte ptr 5;
asm jl repeatQ01Def;
asm mov bl, byte ptr 0;
asm inc bh;
asm clc;
asm sbb cx, word ptr 5;
asm inc dx;
asm cmp bh, byte ptr 8;
asm jl repeatQ01Def;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void plotspriteGun(int xint, int yint)
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov cx, xint;
asm mov dx, yint;
asm mov ax, SEG GunDef;
asm mov ds, ax;
asm mov ax, OFFSET GunDef;
asm mov si, ax;
asm mov bl, byte ptr 0;
asm mov bh, byte ptr 0;
repeatGunDef:;
asm mov al, byte ptr ds:[si];
asm mov ah, 0ch;
asm int 10h;
asm inc si;
asm inc cx;
asm inc bl;
asm cmp bl, byte ptr 5;
asm jl repeatGunDef;
asm mov bl, byte ptr 0;
asm inc bh;
asm clc;
asm sbb cx, word ptr 5;
asm inc dx;
asm cmp bh, byte ptr 8;
asm jl repeatGunDef;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void plotspriteBul(int xint, int yint)
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov cx, xint;
asm mov dx, yint;
asm mov ax, SEG BulDef;
asm mov ds, ax;
asm mov ax, OFFSET BulDef;
asm mov si, ax;
asm mov bl, byte ptr 0;
asm mov bh, byte ptr 0;
repeatGunDef:;
asm mov al, byte ptr ds:[si];
asm mov ah, 0ch;
asm int 10h;
asm inc si;
asm inc cx;
asm inc bl;
asm cmp bl, byte ptr 5;
asm jl repeatGunDef;
asm mov bl, byte ptr 0;
asm inc bh;
asm clc;
asm sbb cx, word ptr 5;
asm inc dx;
asm cmp bh, byte ptr 8;
asm jl repeatGunDef;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void plotspriteExp(int xint, int yint)
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov cx, xint;
asm mov dx, yint;
asm mov ax, SEG ExpDef;
asm mov ds, ax;
asm mov ax, OFFSET ExpDef;
asm mov si, ax;
asm mov bl, byte ptr 0;
asm mov bh, byte ptr 0;
repeatExpDef:;
asm mov al, byte ptr ds:[si];
asm mov ah, 0ch;
asm int 10h;
asm inc si;
asm inc cx;
asm inc bl;
asm cmp bl, byte ptr 5;
asm jl repeatExpDef;
asm mov bl, byte ptr 0;
asm inc bh;
asm clc;
asm sbb cx, word ptr 5;
asm inc dx;
asm cmp bh, byte ptr 8;
asm jl repeatExpDef;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void plotspriteObj(int xint, int yint)
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov cx, xint;
asm mov dx, yint;
asm mov ax, SEG ObjDef;
asm mov ds, ax;
asm mov ax, OFFSET ObjDef;
asm mov si, ax;
asm mov bl, byte ptr 0;
asm mov bh, byte ptr 0;
repeatObjDef:;
asm mov al, byte ptr ds:[si];
asm mov ah, 0ch;
asm int 10h;
asm inc si;
asm inc cx;
asm inc bl;
asm cmp bl, byte ptr 5;
asm jl repeatObjDef;
asm mov bl, byte ptr 0;
asm inc bh;
asm clc;
asm sbb cx, word ptr 5;
asm inc dx;
asm cmp bh, byte ptr 8;
asm jl repeatObjDef;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void plotspriteLiv(int xint, int yint)
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov cx, xint;
asm mov dx, yint;
asm mov ax, SEG LivDef;
asm mov ds, ax;
asm mov ax, OFFSET LivDef;
asm mov si, ax;
asm mov bl, byte ptr 0;
asm mov bh, byte ptr 0;
repeatLivDef:;
asm mov al, byte ptr ds:[si];
asm mov ah, 0ch;
asm int 10h;
asm inc si;
asm inc cx;
asm inc bl;
asm cmp bl, byte ptr 5;
asm jl repeatLivDef;
asm mov bl, byte ptr 0;
asm inc bh;
asm clc;
asm sbb cx, word ptr 5;
asm inc dx;
asm cmp bh, byte ptr 8;
asm jl repeatLivDef;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void plotspriteBlk(int xint, int yint)
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov cx, xint;
asm mov dx, yint;
asm mov ax, SEG BlkDef;
asm mov ds, ax;
asm mov ax, OFFSET BlkDef;
asm mov si, ax;
asm mov bl, byte ptr 0;
asm mov bh, byte ptr 0;
repeatBlkDef:;
asm mov al, byte ptr ds:[si];
asm mov ah, 0ch;
asm int 10h;
asm inc si;
asm inc cx;
asm inc bl;
asm cmp bl, byte ptr 5;
asm jl repeatBlkDef;
asm mov bl, byte ptr 0;
asm inc bh;
asm clc;
asm sbb cx, word ptr 5;
asm inc dx;
asm cmp bh, byte ptr 8;
asm jl repeatBlkDef;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

int main()
{
double doublex[100], doubley[100], doublei[100];
int inttemp;

int xpos, ypos, ipos;
int Bulxpos, Bulypos, Bulipos;
double Objxpos, Objypos, Objipos;
int ObjxD, ObjyD;

int Livxpos, Livypos, Livipos;
int Lives, MaxLives, Work;
int TouchCount;

int setBul;

int ShellBulxpos[100], ShellBulypos[100], ShellBulipos[100];
int ShellsetBul[100], temp;

char keypress, cheat, gamepad;

unsigned long delay, maxspeed;

unsigned long lookcount, lovecount;

int frqHertz;

double Qn[100];

unsigned long Patient;

double centerx, centery, radian, fullradian, currentradian;
int ix, iy;
double radius, degree;

centerx = 155.0;
centery = 100.0;
radian = 3.14159265;
fullradian = 2.0*radian;
currentradian = 0.0;
radius = 25.0;
degree = fullradian/360.0;

srand(time(NULL));

cheat = 'n';

keypress = '';

TouchCount = 0;

gamepad = '';

for(inttemp = 0; inttemp < 100; inttemp++)
{
doublex[inttemp] = (double)(rand()%320);
doubley[inttemp] = 48.0+(double)(rand()%(180-48));
doublei[inttemp] = ((double)(rand()%10))/10.0;
Qn[inttemp] = 0.00;

ShellBulipos[inttemp] = 1;
ShellBulxpos[inttemp] = 155;
ShellBulypos[inttemp] = 180;
ShellsetBul[inttemp] = 0;
}

ipos = 1;
xpos = 155;
ypos = 180;

setBul = 0;

Bulipos = 1;
Bulxpos = 155;
Bulypos = 180;

Objipos = 0.1+(((double)(rand()%10))/10.0);
Objxpos = 1.0+(((double)(rand()%312))/1.0);
Objypos = 48.0;
ObjxD = 1;
ObjyD = 2;

Livipos = 1;
Livxpos = 1;
Livypos = 190;

Lives = 53;
MaxLives = 100;
Patient = 0;

maxspeed = 12000;

menu:;
system("cls");
printf("\n Thank you Jesus Christ.");
printf("\n Honours to my real mom:  Huong Thi Vu");
printf("\n Honours to my real dad:  Nguyen Binh Thuy");
printf("\n Bless my real mom too.");
printf("\n ");
printf("\n Created using Turbo C, Copyright (C) Borland 1987, 1988.");
printf("\n ");
printf("\n Keys during game are: a-left, d-right, f-fire, q-quit.");
printf("\n The object of the game is to touch the ship 100 times.");
printf("\n Please press a key to continue.  Thx.");
printf("\n");
printf("\n [T]est gamepad in DOSBox (0.74).");
printf("\n [G]amepad(s) in use for PC.");
printf("\n");
printf("\n Gamepad requires:");
printf("\n  Microsoft XBOX360 gamepad/controller");
printf("\n  SONY PS ONE gamepad/controller");
printf("\n   (both needs USB adapter)");
printf("\n");
printf("\n [0] during game speeds up or slows down");
gamepad = '';
checkfirst:;
if( kbhit() )
{
gamepad = getch();
}

if(gamepad == 'T'||gamepad == 't')
{
for(delay = 0; delay < 12000; delay++)
{
system("cls");
printf("\n gamepad-A x value = %d", xgamepad());
printf("\n gamepad-A y value = %d", ygamepad());
printf("\n gamepad-B x value = %d", x2gamepad());
printf("\n gamepad-B y value = %d", y2gamepad());
printf("\n gamepad A&B value = %d", buttongamepad());
}
goto menu;
}

if(gamepad == 'g'||gamepad == 'G')
{
gamepad = 'g';
goto startgame;
}

if(gamepad == '')
{
goto checkfirst;
}

startgame:;
setpage();

gotoxy(1, 1);
printf("a-left, d-right, f-fire, q-quit [gunner]");
gotoxy(1, 2);
if(cheat == 'n')
{
printf("7-cheat mode is off");
}
else
{
printf("7-cheat mode is on");
}
gotoxy(1, 3);
if(gamepad == 'g'||gamepad == 'G')
{
printf("g-gamepad is in use [j,k,l,i,space]");
}
else
{
printf("g-gamepad is not in use            ");
}

for(Work = 0; Work < Lives; Work = Work + 1)
{
plotspriteLiv(Livxpos+(Work*6), Livypos);
}

looper:;

for(inttemp = 0; inttemp < 100; inttemp++)
{
plotxyc((int)doublex[inttemp], (int)doubley[inttemp], 0);
doublex[inttemp] = doublex[inttemp] + doublei[inttemp];
doubley[inttemp] = doubley[inttemp] + doublei[inttemp];

if((doublex[inttemp] >= 320.0)&&(doubley[inttemp] >= 180.0))
{
/*
plotxyc((int)doublex[inttemp], (int)doubley[inttemp], 0);
*/
doublex[inttemp] = 0.0;
doubley[inttemp] = 48.0;
}
else if(doublex[inttemp] >= 320.0)
{
/*
plotxyc((int)doublex[inttemp], (int)doubley[inttemp], 0);
*/
doublex[inttemp] = 0.0;
}
else if(doubley[inttemp] >= 180.0)
{
/*
plotxyc((int)doublex[inttemp], (int)doubley[inttemp], 0);
*/
doubley[inttemp] = 48.0;
}
plotxyc((int)doublex[inttemp], (int)doubley[inttemp], 15);

}

for(delay = 0; delay < maxspeed; delay++)
{
asm nop;
}

plotspriteGun(xpos, ypos);

if( kbhit() )
{
keypress = getch();

if(keypress == 'q')
{
goto exitroutine;
}

gotoxy(20, 2);
if(keypress == '0')
{
if(maxspeed == 12000)
{
maxspeed = 12;
printf(" [faster]");
}
else
{
maxspeed = 12000;
printf(" [slower]");
}
}

/*
if(keypress == 'g'||keypress == ' ')
*/
if(keypress == 'g')
{
if(gamepad == 'g')
{
gamepad = '';
}
else
{
gamepad = 'g';
}
}


}

gotoxy(1, 3);
if(gamepad == 'g'||gamepad == 'G')
{
printf("g-gamepad is in use [j,k,l,i,space]");
}
else
{
printf("g-gamepad is not in use            ");
}

/*
if(gamepad == 'g'||gamepad == 'G')
{
if((xgamepad() == 1)||(x2gamepad() == 1))
{
keypress = 'a';
}
else if((xgamepad() == 254)||(x2gamepad() == 254))
{
keypress = 'd';
}
else if((buttongamepad() != -31504))
{
keypress = 'f';
}
}
*/

if(gamepad == 'g'||gamepad == 'G')
{
if(( xgamepad() == 1||x2gamepad() == 1 )||( keypress == 'j' ))
{

for(currentradian = 0.0; currentradian < fullradian; currentradian = currentradian + degree)
{
ix = (int)(centerx+(cos(currentradian)*radius));
iy = (int)(centery+(sin(currentradian)*radius));
plotxyc(ix, iy, 0);
}

if( centerx > radius )
{
centerx = centerx - 10.0;
}

for(currentradian = 0.0; currentradian < fullradian; currentradian = currentradian + degree)
{
ix = (int)(centerx+(cos(currentradian)*radius));
iy = (int)(centery+(sin(currentradian)*radius));
plotxyc(ix, iy, 14);
}

}

if(( xgamepad() == 254||x2gamepad() == 254 )||( keypress == 'l' ))
{

for(currentradian = 0.0; currentradian < fullradian; currentradian = currentradian + degree)
{
ix = (int)(centerx+(cos(currentradian)*radius));
iy = (int)(centery+(sin(currentradian)*radius));
plotxyc(ix, iy, 0);
}

if( centerx < (320.0-radius) )
{
centerx = centerx + 10.0;
}

for(currentradian = 0.0; currentradian < fullradian; currentradian = currentradian + degree)
{
ix = (int)(centerx+(cos(currentradian)*radius));
iy = (int)(centery+(sin(currentradian)*radius));
plotxyc(ix, iy, 14);
}

}

if(( ygamepad() == 1||y2gamepad() == 1 )||( keypress == 'i' ))
{

for(currentradian = 0.0; currentradian < fullradian; currentradian = currentradian + degree)
{
ix = (int)(centerx+(cos(currentradian)*radius));
iy = (int)(centery+(sin(currentradian)*radius));
plotxyc(ix, iy, 0);
}

if( centery > (radius+48.0) )
{
centery = centery - 10.0;
}

for(currentradian = 0.0; currentradian < fullradian; currentradian = currentradian + degree)
{
ix = (int)(centerx+(cos(currentradian)*radius));
iy = (int)(centery+(sin(currentradian)*radius));
plotxyc(ix, iy, 14);
}

}

if(( ygamepad() == 254||y2gamepad() == 254 )||( keypress == 'k' ))
{

for(currentradian = 0.0; currentradian < fullradian; currentradian = currentradian + degree)
{
ix = (int)(centerx+(cos(currentradian)*radius));
iy = (int)(centery+(sin(currentradian)*radius));
plotxyc(ix, iy, 0);
}

if( centery < (180.0-radius) )
{
centery = centery + 10.0;
}

for(currentradian = 0.0; currentradian < fullradian; currentradian = currentradian + degree)
{
ix = (int)(centerx+(cos(currentradian)*radius));
iy = (int)(centery+(sin(currentradian)*radius));
plotxyc(ix, iy, 14);
}

}

if((( buttongamepad() != -31504 )||( keypress == ' ' ))&&( Lives > 0 ))
{

if(cheat == 'n')
{
Lives = Lives - 1;
}
if(Lives < 53)
{
plotspriteBlk(Livxpos + (6*Lives), Livypos);
}
if(Lives < 1)
{
Lives = 0;
/*
goto exitroutine;
*/
}

temp = 15;
for(currentradian = radian/2.0; currentradian < (3.0/4.0)*fullradian; currentradian = currentradian + degree)
{
ix = (int)(centerx+(cos(currentradian)*radius));
iy = (int)(centery+(sin(currentradian)*radius));
if((ix-radius <= Objxpos)&&(iy == Objypos)&&(Objxpos <= ix+radius))
{
temp = 14;
for(frqHertz = 0; frqHertz < 1200; frqHertz++)
{
sound(frqHertz);
}
nosound();
}
}

if(temp == 14)
{
if(Lives < 53)
{
plotspriteLiv(Livxpos + (6*Lives), Livypos);
}
Lives = Lives + 1;
TouchCount++;
gotoxy(1, 4);
printf("goal = 100; actual = %d", TouchCount);
if(TouchCount >= 100)
{
goto YouWin;
}
}

for(radius = 0.0; radius < 25.0; radius = radius + 5.0)
{
for(currentradian = 0.0; currentradian < fullradian; currentradian = currentradian + degree)
{
ix = (int)(centerx+(cos(currentradian)*radius));
iy = (int)(centery+(sin(currentradian)*radius));
plotxyc(ix, iy, temp);
}
}

for(radius = 0.0; radius < 25.0; radius = radius + 5.0)
{
for(currentradian = 0.0; currentradian < fullradian; currentradian = currentradian + degree)
{
ix = (int)(centerx+(cos(currentradian)*radius));
iy = (int)(centery+(sin(currentradian)*radius));
plotxyc(ix, iy, 0);
}
}

radius = 25.0;
}
}

if (keypress == 'a')
{
if( xpos > 0 )
{
xpos = xpos - ipos;
}
}

if (keypress == 'd')
{
if( xpos < 320 )
{
xpos = xpos + ipos;
}
}

if (keypress == '7')
{
keypress = '';
if(cheat == 'n')
{
cheat = 'y';
}
else
{
cheat = 'n';
}
}

gotoxy(1, 2);
if(cheat == 'n')
{
printf("7-cheat mode is off");
}
else
{
printf("7-cheat mode is on ");
}

if ( (keypress == 'f')&&(Lives > 0))
{
keypress = '';
temp = 0;
CheckNextShell:;
if( ShellsetBul[temp] == 0 )
{
if(lookcount == 0)
{
lookcount = 1;
for(delay = 0; delay < 5000; delay++)
{
sound(1200);
}
}
if(cheat == 'n')
{
Lives = Lives - 1;
}
if(Lives < 53)
{
plotspriteBlk(Livxpos + (6*Lives), Livypos);
}
if(Lives < 1)
{
Lives = 0;
/*
goto exitroutine;
*/
}
ShellsetBul[temp] = 1;
}
else
{
temp = temp + 1;
if( temp < 100  )
{
goto CheckNextShell;
}
}

}



if(Lives < 1)
{
if(Patient == 0)
{
Lives = 0;
Patient++;
}
else
{
Patient++;
if(Patient > 1200)
{
plotspriteLiv(Livxpos + (6*Lives), Livypos);
Lives++;
Patient = 0;
}
}
}

for(temp = 0; temp < 100; temp++)
{
if( ShellsetBul[temp] == 1 )
{
Qn[temp] = 0.0;
ShellsetBul[temp] = 2;
ShellBulxpos[temp] = xpos;
ShellBulypos[temp] = ypos;
ShellBulipos[temp] = ipos;
}

}

for(temp = 0; temp < 100; temp++)
{


if( ShellsetBul[temp] == 2 )
{
if(lookcount > 0)
{
lookcount++;
if((lookcount >= 5))
{
lookcount = 0;
nosound();
}
}

if( ShellBulypos[temp] > 48 )
{
ShellBulypos[temp] = ShellBulypos[temp] - ShellBulipos[temp];

/*
plotspriteBul(Bulxpos, Bulypos);
*/

Qn[temp] = Qn[temp] + 0.2;
if(Qn[temp] >= 5.0)
{
Qn[temp] = 1.0;
}
if(Qn[temp] < 2.0)
{
plotspriteQ01(ShellBulxpos[temp], ShellBulypos[temp]);
}
else if(Qn[temp] < 3.0)
{
plotspriteQ02(ShellBulxpos[temp], ShellBulypos[temp]);
}
else if(Qn[temp] < 4.0)
{
plotspriteQ03(ShellBulxpos[temp], ShellBulypos[temp]);
}
else
{
plotspriteQ04(ShellBulxpos[temp], ShellBulypos[temp]);
}


}
else
{
ShellsetBul[temp] = 0;
plotspriteBlk(ShellBulxpos[temp], ShellBulypos[temp]);
ShellBulypos[temp] = 1;
ShellBulxpos[temp] = 312;
}

}


}

if(   ObjxD == 0)
{
if(Objxpos > 0)
{
Objxpos = Objxpos - Objipos;
}
else
{
ObjxD = 1;
}
}

if(ObjxD == 1   )
{
if(Objxpos < 320)
{
Objxpos = Objxpos + Objipos;
}
else
{
ObjxD = 0;
}
}

for(temp = 0; temp < 100; temp++)
{
if((((Objxpos-5)<(ShellBulxpos[temp]))&&((ShellBulxpos[temp])<(Objxpos+5)))&&(((Objypos-5)<(ShellBulypos[temp]))&&((ShellBulypos[temp])<(Objypos+5))))
{
plotspriteExp(Objxpos, Objypos);
for(delay = 0; delay < 5000; delay++)
{
sound(delay);
}
nosound();
plotspriteBlk((int)Objxpos, (int)Objypos);
Objipos = 0.1+(((double)(rand()%10))/10.0);
Objxpos = 1.0+(((double)(rand()%312))/1.0);
Objypos = 48.0+(((double)(rand()%(150-48)))/1.0);
if(Lives < 53)
{
plotspriteLiv(Livxpos + (6*Lives), Livypos);
}
Lives = Lives + 1;
TouchCount++;
gotoxy(1, 4);
printf("goal = 100; actual = %d", TouchCount);
if(TouchCount >= 100)
{
goto YouWin;
}
}
else
{
plotspriteObj(Objxpos, Objypos);
}
}

goto looper;

YouWin:;
setpage();
retpage();
system("cls");
printf("\n You Win.");
getch();
printf("\n JESUS CHRIST; MY THE LORD OF ALL HOSTS!");
getch();
printf("\n DAD: NGUYEN BINH THUY");
printf("\n MOM: HUONG THI VU");
printf("\n COUSIN, CARL, ANH CUONG CAO VU");
getch();

printf("\n JESUS CHRIST!..MY THE LORD OF ALL HOSTS.");
printf("\n DAD NGUYEN BINH THUY");
printf("\n MOM HUONG THI VU:");
printf("\n XIN CAM ON CHUA DA CHO TOAN THE GIA DINH");
printf("\n  CON TOT DEP.  VA XIN CHUA CAM CHO CON");
printf("\n  CUA CON BINH THAN LAI.");
printf("\n   CON XIN CHUA VA DUC ME.");
printf("\n  CON CUA CON LA NGUYEN KHOA TIEN!");
printf("\n SISTER NGUYEN KHOA THI, AND THUYEN");
getch();

printf("\n COUSIN CARL ANH CUONG CAO VU");
printf("\n JEANNIE VU");
printf("\n STEVEN VU");
printf("\n TIDO VU");
printf("\n JACKIE VU");
printf("\n AMANDA VU");
printf("\n ASHLEY VU");
printf("\n ALEX VU");
printf("\n CORY VU");
printf("\n JAN VU");
printf("\n ALLISON VU");
printf("\n LAURA VU");
printf("\n ALANIS VU");
printf("\n ALENA VU");
printf("\n NINA TRAN");
printf("\n BAC HUYNH");
printf("\n CO TIEN");
printf("\n GRANDMA");
printf("\n SOPHIA THUY VU");
printf("\n DOCTOR CAU THAO");
printf("\n CAU TRIEM");
printf("\n THAO");
printf("\n CHI HOA");
printf("\n CHI LAN");
printf("\n CAU TRUOC");
printf("\n CINDY VU");
printf("\n THERESA VU");
printf("\n JENNIFER VU");
printf("\n JOHN VU");
printf("\n JAMES VU");
printf("\n QUADKO");
printf("\n DAVID BRACKEEN");
printf("\n JVS");
printf("\n MRFLIBBLE");
printf("\n PSEUDOCODER");
printf("\n DANIEL COOK");
printf("\n JOHN CARMACK");
printf("\n ALLEN PILGRIM AND SON");
printf("\n DOSGUY");
printf("\n LUNICK");
printf("\n MIKE");
printf("\n AL");
printf("\n MANNY");
printf("\n WALMART");
printf("\n KROGER");
printf("\n FIESTA");
printf("\n NIEMEN MARCUS");
printf("\n ART LINCH");
printf("\n CHAD JON");
printf("\n TOM TAYLOR");
printf("\n PEGGY");
printf("\n DENISE");
getch();
printf("\n WWW.DONOHOS.COM");
printf("\n WWW.DOSGAMES.COM");
printf("\n WWW.CLASSICDOSGAMES.COM");
printf("\n WWW.PLAYDOSGAMES.COM");
printf("\n WWW.ARTENSOFT.COM");
printf("\n RFOBASIC.FREEFORUMS.ORG");
getch();
printf("\n USPS.COM");
printf("\n TUTORIALSPOINT.COM");
printf("\n TARGET");
printf("\n PROGRAMMERSHEAVEN.COM");
printf("\n WWW.CHESS.COM");
getch();
printf("\n WWW.CHESSFORUMS.ORG");
printf("\n WWW.PELLESC.COM");
printf("\n XFINITY.COM");
printf("\n RELIANT.COM");
printf("\n OFFICEDEPOT.COM");
getch();
printf("\n COMCAST IVAN");
getch();
printf("\n PAPPADEAUX SEAFOOD PLACE");
printf("\n HOLLISTER AND NW FWY");
printf("\n HOUSTON TEXAS");
getch();
printf("\n MEL AND HALLFIRY");
getch();
printf("\n CHRISTY FROM TOSHIBA");
printf("\n SOUMYA B FROM ADOBE");
printf("\n MICROSOFT");
printf("\n RICHARD AND NICK AT GOODMAN");
printf("\n HONDA");
printf("\n MAZDA");
printf("\n BMW");
printf("\n MERCEDES");
getch();
printf("\n HOLLYWOOD");
getch();
printf("\n SOCIAL SECURITY");
getch();
printf("\n PIXELTHING");
getch();
printf("\n DAVID NGUYEN FROM FOXCONN");
printf("\n MARY CREWS AT WELLSFARGO");
getch();
printf("\n SHELLY AT MANPOWER HOUSTON TX");
getch();
printf("\n ALL THE BABES AND COOL DUDES");
getch();
printf("\n BE HAPPY ALL THE TIME NOW.");
getch();
printf("\n IBM");
printf("\n INTEL");
printf("\n USA");
printf("\n VIETNAM");
printf("\n AND SUCH HEHE");
getch();
printf("\n NVIDIA");
printf("\n AMD");
printf("\n ATI");
getch();
printf("\n TOM HARDWARE");
printf("\n DENIWEB");
printf("\n ST.JUDE");
getch();
printf("\n MORE HOPEFULLY...EVERYONE");
printf("\n WWW.VETUSWARE.ORG");
getch();
printf("\n IM SORRY FOR HALLOWEEN");
printf("\n THANK YOU ALL!");
getch();
return(0);

YouLose:;
retpage();
printf("\n We will see you next life!");
getch();
return(0);

exitroutine:;
retpage();
return(0);
}
